/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.ParadaDAO;
import com.rjconsultores.ventaboletos.dao.TipoParadaDAO;
import com.rjconsultores.ventaboletos.entidad.TipoParada;
import com.rjconsultores.ventaboletos.service.TipoParadaService;
import com.rjconsultores.ventaboletos.utilerias.RegistroConDependenciaException;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("tipoParadaService")
public class TipoParadaServiceImpl implements TipoParadaService {

    @Autowired
    private TipoParadaDAO tipoParadaDAO;
    @Autowired
    private ParadaDAO paradaDAO;

    public List<TipoParada> obtenerTodos() {
        return tipoParadaDAO.obtenerTodos();
    }

    public TipoParada obtenerID(Integer id) {
        return tipoParadaDAO.obtenerID(id);
    }

    @Transactional
    public TipoParada suscribir(TipoParada entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return tipoParadaDAO.suscribir(entidad);
    }

    @Transactional
    public TipoParada actualizacion(TipoParada entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return tipoParadaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(TipoParada entidad) throws RegistroConDependenciaException{
        if (paradaDAO.count(entidad) > 0l) {
             throw new RegistroConDependenciaException();
        }
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        tipoParadaDAO.actualizacion(entidad);
    }

    public List<TipoParada> buscar(String desctipo) {
        return tipoParadaDAO.buscar(desctipo);
    }
}
